// Copyright (c) 2017, Tobias Mueller tm(at)tm3d.de
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
//  * Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the
//    distribution.
//  * All advertising materials mentioning features or use of this
//    software must display the following acknowledgement: This product
//    includes software developed by tm3d.de and its contributors.
//  * Neither the name of tm3d.de nor the names of its contributors may
//    be used to endorse or promote products derived from this software
//    without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef __OWARDUINOINTERFACES_H_
#define __OWARDUINOINTERFACES_H_

#include "owInterface.h"

class owARDUINOInterface:public owInterface{
protected: 
#ifdef LINUX
	int fd;
#endif
#ifdef WIN
	HANDLE fd;
#endif
	int com_init;
public:
	owARDUINOInterface():owInterface() {
		fd=0;
		com_init=0;
	}
	virtual int InitAdapter(uint8_t);
	virtual int Reset();
	virtual uint8_t sendrecivBit(uint8_t bit);
	virtual uint8_t sendrecivByte(uint8_t byte);
	virtual void ReleaseAdapter();
	virtual int owFirst();
	virtual int owNext();
	virtual int Communicate(std::vector<uint8_t> *data, int scount, int rcount);


protected:
	uint8_t ULevel; // current DS2480B 1-Wire Net level
	uint8_t UBaud;  // current DS2480B baud rate
	uint8_t UMode;  // current DS2480B command or data mode state
	uint8_t USpeed; // current DS2480B 1-Wire Net communication speed
	uint8_t UVersion; // current DS2480B version 
#ifdef LINUX
	struct termios origterm;
#endif
#ifdef LINUX
	int OpenCOM(uint8_t comnr);
#endif
#ifdef WIN
	HANDLE OpenCOM(uint8_t comnr);
#endif

	void CloseCOM();
	void FlushCOM();
	int  WriteCOM(int outlen, uint8_t *outbuf);
	int ReadCOM(int inlen, uint8_t *inbuf);
//	void BreakCOM();

	
};

#endif
